//all functions are based off of participantManager (print, config, etc.)

function addSelectOptions(){
   let pM=this;
   if (pM.mode=="LOCAL") return;
   
   let input=pM.getInputElement();
   let config=pM.config;

   let fName='addParticipantSelectOptions';
   pM.print(fName+' input '+input);
   let opt=config.document.createElement("option");
   opt.value=-1;

   opt.text="<Select>";
   input.options[input.options.length]=opt;

   //here the lookup is being populated (registrationData)
   let demoRows=config.formConfig['registrationData'].rows;
   pM.print(fName+" demoRows: "+demoRows.length);
   for (let i=0;i<demoRows.length;i++){
      let opt2=config.document.createElement("option");
      opt2.value=i+1;
      let id=demoRows[i][pM.getCrfEntryFieldName()];
      let loc=demoRows[i][pM.getCrfEntryFieldName('LOCAL')];
      opt2.text=id+' (Local: '+loc+')';
      input.options[input.options.length]=opt2;
      pM.print(fName+' '+pM.participantField+' '+demoRows[i][pM.participantField]);
   }

   input.selectedIndex=0;
}

function updateElements(){
   let pM=this;
   let fName='[updateElements]';
   //reset all values (some might be different depending on the call timing)

   //selector is with study
   pM.cellSelector=config.document.getElementById(pM.cellSelectorId);
   pM.inputSelector=config.document.getElementById(pM.inputSelectorId);
   pM.textStudy=config.document.getElementById(pM.textStudyId);
  
   pM.print(fName+' selector '+pM.inputSelector+' id '+pM.inputSelectorId);
   //value is with local
   pM.cellValue=config.document.getElementById(pM.cellValueId);
   pM.inputValue=config.document.getElementById(pM.inputValueId);
   pM.textLocal=config.document.getElementById(pM.textLocalId);
   
   //pM.inputManageLocal=config.document.getElementById(pM.inputManageLocalId);
   //pM.inputManageStudy=config.document.getElementById(pM.inputManageStudyId);
}

function generateEntryField(){
   let pM=this;
   let fName='[generateParticipantEntryField]:';
   pM.print(fName);

   //this is HTML designator of area on page
   let config=pM.config;
	let formName=config.masterForm;

    
   pM.tb=config.document.createElement('table');
   let tb=pM.tb;
	tb.className='t2';
	let row=tb.insertRow();
	
   //label for local ID
   let cell=config.document.createElement('th');
	row.appendChild(cell);	
	cell.setAttribute("colspan","1");
	cell.style.fontSize="20px";
	cell.style.textAlign="left";
   //Use study coding for participant field
   cell.innerText='Local ID';
	//cell.innerText=pM.participantField;


   //value
   let cellValue=row.insertCell();
   cellValue.id=pM.cellValueId;

   pM.cellManageLocal=row.insertCell();
   
   //second row for study id
   let rowStudy=tb.insertRow();

   //label for study ID
   let cellStudy=config.document.createElement('th');
	rowStudy.appendChild(cellStudy);	
	cellStudy.setAttribute("colspan","1");
	cellStudy.style.fontSize="20px";
	cellStudy.style.textAlign="left";
   //Use study coding for participant field
   cellStudy.innerText='Study ID';

	//selector for study id
   let cellSelector=rowStudy.insertCell();
   cellSelector.id=pM.cellSelectorId;

   //manage
   pM.cellManageStudy=rowStudy.insertCell();
   config.document.getElementById(formName).appendChild(tb);
   pM.print(fName+' done');

}

function getMode(mode="NONE"){
   let pM=this;
   if (mode=="NONE") return pM.mode;
   return mode;
}

//reslovers which operate depending on mode
function getInputId(mode="NONE"){
   let pM=this;
   let fName='[getInputId]';
   pM.print(fName);
   if (pM.getMode(mode)=="LOCAL") return pM.inputValueId;
   return pM.inputSelectorId;
}


function getInputCell(mode="NONE"){
   let pM=this;
   let fName='[getInputCell]';
   pM.print(fName+' mode '+mode+' getMode '+pM.getMode(mode));
   if (pM.getMode(mode)=="LOCAL") return pM.cellValue;
   return pM.cellSelector;
}

function getInputElement(mode="NONE"){
   let pM=this;
   let fName='[getInputElement]';
   pM.print(fName);
   let elementType=pM.getInputElementType(mode);
   let id=pM.getInputId(mode);
   let cell=pM.getInputCell(mode);
   let el=pM.config.document.getElementById(id);
   pM.print(fName+' mode '+pM.getMode(mode)+' type '+elementType+' id '+id+' cell '+cell+' el '+el);
   if (el) return el;

   el=pM.config.document.createElement(elementType);
   print(fName+' input '+el);
   el.id=id;

   cell.replaceChildren(el);
   pM.addSelectOptions();
 
   return el;
}

function getInputElementType(mode="NONE"){
   let pM=this;
   let fName='[getInputElementType]';
   pM.print(fName);
   if (pM.getMode(mode)=="LOCAL") return "input";
   return "select";
}


function getTextFieldId(mode="NONE"){
   let pM=this;
   let fName='[getTextFieldId]';
   pM.print(fName);
   if (pM.getMode(mode)=="LOCAL") return pM.textLocalId;
   return pM.textStudyId;
}

  
function getTextElement(mode="NONE"){
   let pM=this;
   let fName='[getTextElement]';
   pM.print(fName+' mode '+mode);
   let id=pM.getTextFieldId(mode);
   pM.print(fName+' id '+id);
   let el=pM.config.document.getElementById(id);
   pM.print(fName+' el '+el);
   if (el) return el;
   el=config.document.createElement("p");
   el.id=id;
   let cell=pM.getInputCell(mode);
   //let oldEl=pM.getInputElement(mode);
   cell.replaceChildren(el);
   return el;
}


//get the button, create if not there yet
function getInputManage(mode="NONE"){
   let pM=this;
   let fName='[getInputManage]';
   //pM.print(fName);
   let config=pM.config;
   //this prevents from having two inputs; it is either local or global from the outset
   if ("inputManage" in pM) return pM.inputManage;

   pM.inputManage=config.document.createElement("input");
   let inputManage=pM.inputManage;
   inputManage.type="button";
   inputManage.onclick=function(){pM.manageId();};
   //inputManageLocal.id=pM.inputManageLocalId;
   let cell=pM.cellManageStudy;
   if (pM.getMode(mode)=="LOCAL") cell=pM.cellManageLocal;
   //pM.print(fName+' inputManage '+pM.inputManage+' cell '+cell+' mode '+pM.mode);
   cell.appendChild(inputManage);
   return inputManage;
}

//callback that splits to edit or set/label mode
function manageId(){
   let pM=this;
   let fName='[manageId]';
   pM.print(fName);
   //this can happen after object was created, so make sure current
   //elements are used
   pM.updateElements();
   let x=pM.getInputManage();

   if (x.value=="Set"){
      pM.setId();
      return;
   }
   if (x.value=="Edit"){
      pM.editId();
      return;
   }
}

//set mode
function setId(){
   let pM=this;
   let fName='[setId]';
   pM.print(fName);
   let el=pM.getInputElement();

   pM.print(fName+" value: "+el.value);
   let pId=el.value;
   let label=pId;
   if (pM.mode!="LOCAL"){
      if (el.value<0) return;
      let opt=el.options[el.selectedIndex];
      label=opt.text;
      pId=label.replace(/\(.*\)/,'');
      label=label.replace(/ \(Local: /,':');
      label=label.replace(/\)/,'');
   }
   pM.setParticipantIdToCrfEntry(pId);//no argument (should come from mode)
   pM.print(fName+" new value "+pId);
   pM.setLabelMode(label);
   pM.updateCrfEntry();
}

function setLabelMode(pId){
   let fName='[setLabelMode1]';
   let pM=this;
   let config=pM.config;

   pM.print(fName+' id '+pId);
   ids=pId.split(':');

   let textValue=pM.getTextElement();
   pM.print(fName+' textElement '+textValue);
   textValue.innerText=ids[0];

   if (pM.mode=="STUDY"){
      let loc=ids[1];
      //pM.getParticipantIdFromCrfEntry('LOCAL');
      pM.print(fName+' setting local id '+loc);
      let tValLocal=pM.getTextElement('LOCAL');
      tValLocal.innerText=loc;
      pM.setParticipantIdToCrfEntry(loc,'LOCAL');
   }

   let x=pM.getInputManage();//getInputManage
   if ("readOnly" in pM){
      x.style.display="none";
   }
   x.value="Edit";

   
}

//edit mode
function editId(){
   let pM=this;
   pM.setEditMode();
}

function setEditMode(){
   let pM=this;
   let config=pM.config;

   let fName='[setEditMode1]';
   pM.print(fName+' pM '+pM+' mode '+pM.mode);
   //input
   let el=pM.getInputElement();

   let x=pM.getInputManage();
   x.value="Set";

}

//manage interaction to storage/CRF and study/LabKey
function getParticipantField(config){
   return config.formConfig['studyDataAll'].rows[0]['SubjectColumnName'];
}

function getCrfEntryFieldName(mode="NONE"){
   let pM=this;
   let variable="Study";
   if (mode=="NONE") mode=pM.mode;
   if (mode=="LOCAL") variable="Local";
   return 'participant'+variable+'Id';
}

function setParticipantIdToCrfEntry(pId,mode="NONE"){
   let pM=this;
   let config=pM.config;
   config.formConfig.crfEntry[pM.getCrfEntryFieldName(mode)]=pId;
}

function getParticipantIdFromCrfEntry(mode="NONE"){
   let pM=this;
   let config=pM.config;
   return config.formConfig.crfEntry[pM.getCrfEntryFieldName(mode)];
}

//main interface. Use this to generate object and to refer to it later on
function getParticipantManagerObject(config){

   let fName='[getParticipantManagerObject]';
   config.print(fName);
   if ("participantManager" in config) {
      let pM=config.participantManager;
      pM.updateElements();
      return pM;
   }

   let pM=new Object();
   //circular reference to traverse pM up and down
   config.participantManager=pM;
   pM.config=config;
   //config should have a print routine
   pM.print=config.print;

   //this never change
   pM.participantField=getParticipantField(config);


   pM.cellSelectorId=pM.participantField+"_cellSelect";
   pM.inputSelectorId=pM.participantField+"_Select";
   pM.textStudyId=pM.participantField+"_textStudy";

   pM.cellValueId=pM.participantField+"_cellValue";
   pM.inputValueId=pM.participantField+"_Value";
   pM.textLocalId=pM.participantField+"_textLocal";

   pM.inputManageLocalId=pM.participantField+"_ManageLocal";
   pM.inputManageStudyId=pM.participantField+"_ManageStudy";

   pM.mode="LOCAL";//or "STUDY"

   //add methods
   pM.getMode=getMode;

   //global methods that are not subject to mode modifier
   pM.updateElements=updateElements;
   pM.addSelectOptions=addSelectOptions;
   pM.generateEntryField=generateEntryField;

   //getters subject to mode
   pM.getInputId=getInputId;
   pM.getInputCell=getInputCell;
   pM.getInputElement=getInputElement;
   pM.getInputElementType=getInputElementType;

   pM.getTextFieldId=getTextFieldId;
   pM.getTextElement=getTextElement;

   pM.getInputManage=getInputManage;

   //callback
   pM.manageId=manageId;
   
   //set/label mode
   pM.setId=setId;
   pM.setLabelMode=setLabelMode;

   //edit mode
   pM.editId=editId;
   pM.setEditMode=setEditMode;
   
   //interact with storage/CRF and study/LabKey
   pM.setParticipantIdToCrfEntry=setParticipantIdToCrfEntry;
   pM.getParticipantIdFromCrfEntry=getParticipantIdFromCrfEntry;
   pM.getCrfEntryFieldName=getCrfEntryFieldName;


   //init
   pM.generateEntryField();
   pM.updateElements();
   return pM;
}
